@echo off

set CACHE_LIB=./lib
set CACHE_OUTPUT=./

setlocal EnableDelayedExpansion
for %%i in ("%CACHE_LIB%\*.jar") do set classpath=!classpath!;%%i
endlocal & set classpath=%classpath%

set AOP_PATH=%CACHE_OUTPUT%/etc/META-INF

set CLASSPATH=%CLASSPATH%;%CACHE_OUTPUT%/etc;%CACHE_OUTPUT%/classes;%CACHE_OUTPUT%/tests
set CP=%CLASSPATH%
set LOG4J=%CACHE_OUTPUT%/etc/log4j.xml
set L4J=%LOG4J%

set ARGS=-Dlog4j.configuration=file:%L4J%

java -cp %CP% "-javaagent:%CACHE_LIB%\jboss-aop-jdk50.jar" %ARGS% -Djboss.aop.path=%AOP_PATH% -Djava.net.preferIPv4Stack=true bsh.Console

