#!/bin/sh

CACHE_HOME=`dirname $0`
CACHE_LIB=$CACHE_HOME/lib
CACHE_OUTPUT=$CACHE_HOME

CLASSPATH=$CACHE_OUTPUT/etc:$CACHE_OUTPUT/classes:$CACHE_OUTPUT/build:$CACHE_OUTPUT/tests

for i in ${CACHE_LIB}/*.jar
do
CLASSPATH=${CLASSPATH}:${i}
done

AOP_PATH=${CACHE_OUTPUT}/resources/pojocache-aop.xml

LOG4J=$CACHE_OUTPUT/etc/log4j.xml

# OS specific support (must be 'true' or 'false').
cygwin=false;
case "`uname`" in
    CYGWIN*)
        cygwin=true
        ;;
esac

if [ $cygwin = "true" ]; then
   CP=`cygpath -wp $CLASSPATH`
   L4J=`cygpath -wp $LOG4J`
else
   CP=$CLASSPATH
   L4J=$LOG4J
fi

#JAVA_OPTS="-Xdebug -Xnoagent -Djava.compiler=NONE -Xrunjdwp:transport=dt_socket,address=5005,server=y,suspend=n"

ARGS="-javaagent:${CACHE_LIB}/jboss-aop-jdk50.jar -Dlog4j.configuration=file:$L4J -Djboss.aop.path=$AOP_PATH -Djava.net.preferIPv4Stack=true"

java -cp $CP $ARGS $JAVA_OPTS bsh.Console &
