package org.jboss.cache.util;

import org.apache.tools.ant.taskdefs.optional.junit.JUnitTest;
import org.apache.tools.ant.taskdefs.optional.junit.XMLJUnitResultFormatter;

public class XMLUnitTestFormatter extends XMLJUnitResultFormatter
{

   public void startTestSuite(JUnitTest test)
   {
      String configuration = (String) System.getProperties().get("jgroups.stack");

      if (configuration != null && !configuration.trim().equals(""))
      {
         test.setName(test.getName() + "(" + configuration + ")");
      }

      super.startTestSuite(test);
   }
}
