package tesAsp;

public aspect AspRemoteCallFromCache {
	
	pointcut remoteCallsFromCache():
		(call(* org.jboss.cache.CacheImpl.callRemoteMethods(..)) ||
		 call(* org.jgroups.blocks.RpcDispatcher.callRemoteMethods(..)) ||
		 call(* org.jboss.cache.buddyreplication.BuddyManager.makeRemoteCall(..)) ||
		 call(* org.jboss.cache.interceptors.*.replicateCall(..)) ||
		 call(* org.jboss.cache.marshall.JBCMethodCall.getMethodId(..)))//;
	    //&& within(org.jboss.cache.CacheImpl);
	    && within(org.jboss.cache.interceptors.*);

	before():remoteCallsFromCache(){
		System.out.println("Remote call invocation");
	}
}
