package org.jboss.cache.pojo.collection;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jboss.cache.pojo.PojoCache;
import org.jboss.cache.pojo.PojoCacheFactory;

/**
 * List interface testing with transaction control.
 *
 * @author Scott Marlow
 */

public class CachedListTxTest extends TestCase
{
   Log log = LogFactory.getLog(CachedListTxTest.class);
   PojoCache cache_;


   public CachedListTxTest(String name)
   {
      super(name);
   }

   protected void setUp() throws Exception
   {
      super.setUp();
      log.info("setUp() ....");
      String configFile = "META-INF/cache-config.xml";
      boolean toStart = false;
      cache_ = PojoCacheFactory.createCache(configFile, toStart);
      cache_.start();

   }

   protected void tearDown() throws Exception
   {
      super.tearDown();
      cache_.stop();
   }

   public void testDummy()
   {
      // No op now.
   }

   public static Test suite() throws Exception
   {
      return new TestSuite(CachedListTxTest.class);
   }

   public static void main(String[] args) throws Exception
   {
      junit.textui.TestRunner.run(suite());
   }

}


