package jasco.runtime.distribution;

import jasco.util.distribution.RemoteInfo;

public class DistributedStandardMessage implements DistributedJascoMessage {
	public static final int NONE =0;
	public static final int REMOTE_JP =1;
	public static final int REMOTE_SYNC_MESSAGE =2;
	public static final int REMOTE_ASYNC_MESSAGE =3;
	public static final int REMOTE_FETCH_ASYNC_RESULT =4;
	
	
	int type = NONE;
    Object msg= null;
    private RemoteInfo remoteInfo;
    
	public DistributedStandardMessage(Object o, int type) {
		super();
		msg = o;
		this.type = type;
		remoteInfo = new RemoteInfo();
	}

	public RemoteInfo getRemoteInfo() {
		return remoteInfo;
	}
	
	public void setType(int type) {
		this.type = type;
	}

	public int getType() {
		return type;
	}

	public void setMsg(Object msg) {
		this.msg = msg;
	}

	public Object getMsg() {
		return msg;
	}

}
