package jasco.runtime.distribution;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

public class FutureWrapper implements InvocationHandler {
	
	private Object value;
	private Host host;
	private long taskid;
	
	public FutureWrapper(Host h1, long taskid) {
		
		this.host=h1;
		this.taskid=taskid;
	}
	
	public Object invoke(Object arg0, Method arg1, Object[] arg2)
			throws Throwable {
		
		return arg1.invoke(getStoredValue(), arg2);
	}
	
	public Object getStoredValue() {
		
		if(value==null)
			value=DistributePointcutHandler.getInstance().getRemoteAsyncResult(host, taskid);
		return value;
	}

}
