package jasco.runtime.distribution;

public interface IHostSet extends java.io.Serializable {
	 
	public boolean containsLocalHost();
	
	/**
	 * returns true iff only execute on local host
	 * @return
	 */
	
	public boolean isLocalHost();
	

	/**
	 * returns the chosen host
	 * @return
	 */
	public IHostSet selectHostsByStrategy();

	public boolean contains(Host host); 
	
	public String toString();

	public Host selectOneHostByStrategy();
}
