/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 20-okt-2004
 */
package jasco.tools.jascoparser;

import jasco.tools.aspectparser.AspectParser;
import jasco.util.generators.MethodGenerator;

/**
 * @author Wim 
 */
public class PMethod extends PContent {

	public PMethod(MethodGenerator gen, int lineno) {
		super(gen,lineno);
	}
	
	
	public MethodGenerator getMethodInfo() {
		return (MethodGenerator) getDescriptor();
	}
	
	public boolean isRefinable() {
		
		return AspectParser.isRefinable(getMethodInfo().getModifiers());
	}
}
