package jasco.util.distribution;

import java.io.IOException;
import java.io.Serializable;
import java.net.Socket;
import java.rmi.server.RMIClientSocketFactory;

/**
 * @author lbenavid
 * 
 */
public class JascoClientSocketFactory implements RMIClientSocketFactory, Serializable {

	public JascoClientSocketFactory() {
	}
	
    public boolean equals(Object obj) {
        return getClass() == obj.getClass();
    }

    public int hashCode() {
        return getClass().hashCode();
    }

    public Socket createSocket(String host, int port) throws IOException {
    	return new JascoSocket(host, port);
    }	

}
