package jasco.util.distribution;


import jasco.runtime.distribution.causality.LocalVectorClock;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.OutputStream;

import org.jgroups.protocols.TransportedVectorTime;

/**
 * @author scastro, lbenavid
 * 
 */
public class JascoOutputStream extends ObjectOutputStream {

	public JascoOutputStream(OutputStream o) throws IOException{
		super(new BufferedOutputStream(o));
		RemoteInfo ri = new RemoteInfo();
		writeObject(ri);
		TransportedVectorTime tvc = LocalVectorClock.getInstance().getLocalClock();
		System.out.println("ObjectOutputStream: local vector clock " + tvc);
		writeObject(tvc);
	}

	
}
