package jasco.util.distribution;

import java.io.IOException;
import java.io.Serializable;
import java.net.ServerSocket;
import java.net.Socket;
import java.rmi.server.RMISocketFactory;

/**
 * @author scastro
 * 
 */
public class JascoSocketFactory extends RMISocketFactory implements Serializable {

    public boolean equals(Object obj) {
        return getClass() == obj.getClass();
    }

    public int hashCode() {
        return getClass().hashCode();
    }

    public ServerSocket createServerSocket(int port) throws IOException {
    	return (ServerSocket) new JascoServerSocket(port);
    }

    public Socket createSocket(String host, int port) throws IOException {
    	return new JascoSocket(host, port);
    }	


}


