package jasco.util.distribution;

import jasco.runtime.distribution.Host;

import java.io.Serializable;

/**
 * @author scastro
 * 
 */
public class StackInfo implements Serializable{
	
	private String[] stack;
	private Host host;

	public StackInfo(String[] stack, Host host) {
		this.stack = stack;
		this.host = host;
	}

	public StackInfo() {
		setStack(getCflowStringArray());
		setHost(Host.getLocalHost());
	}

	private String[] getCflowStringArray(){
		return jasco.runtime.RuntimeContext.getStackContents();
	}

	public Host getHost() {
		return host;
	}

	public void setHost(Host host) {
		this.host = host;
	}

	public String[] getStack() {
		return stack;
	}

	public void setStack(String[] stack) {
		this.stack = stack;
	}

}










