package Connector;

import java.lang.*;
import java.util.*;
import jasco.runtime.aspect.*;
import jasco.runtime.connector.*;
import jasco.runtime.*;
import test.basic.*;
import sunw.demo.juggler.*; //3


public class basic2Connector  implements Connector {

	private Vector methods = new Vector();

	private Vector combinationStrategies = new Vector();

	private Vector instances = new Vector();

	private static basic2Connector myinstance = new basic2Connector();

	private boolean isClassAdapter = true;

	private boolean isEnabled = true;

	private boolean doNotCache = false;

	private Vector cutpoints = new Vector();

	private Vector methodHashtableVector = new Vector();

	private String filename;

	private int priority;

	public final test.basic.tester tester = new test.basic.tester();

	public final tester_ExecuteHook temp = new test.basic.tester_ExecuteHook(tester);

	public final tester_CallHook temp2 = new test.basic.tester_CallHook(tester);

	public final test.basic.cflowClass cflowClass = new test.basic.cflowClass();

	public final cflowClass_cflowtest temp3 = new test.basic.cflowClass_cflowtest(cflowClass);

	private HookElement temp_cutpoint = new HookElement (temp, new CutpointExecutionElement(false,10000), new CutpointExecutionElement(false,10000), new CutpointExecutionElement(true,10000), "temp");

	private HookElement temp2_cutpoint = new HookElement (temp2, new CutpointExecutionElement(true,10000), new CutpointExecutionElement(false,10000), new CutpointExecutionElement(false,10000), "temp2");

	private HookElement temp3_cutpoint = new HookElement (temp3, new CutpointExecutionElement(true,10000), new CutpointExecutionElement(false,10000), new CutpointExecutionElement(false,10000), "temp3");


	static {

	myinstance.temp._Jasco_setCutpointName("temp");
	myinstance.temp2._Jasco_setCutpointName("temp2");
	myinstance.temp3._Jasco_setCutpointName("temp3");
	}

	private static  void addCombinationStrategy(CombinationStrategy aStrategy)  {
	
		myinstance.combinationStrategies.addElement(aStrategy);
	
	}


	public  void addInstance(Object object)  {
	
		instances.addElement(object);
	
	}


	public  void removeInstance(Object object)  {
	
		instances.removeElement(object);
	
	}


	public static  basic2Connector getConnector()  {
	
		return myinstance;
	
	}


	public  boolean adaptOnClasses()  {
	
		return isClassAdapter;
	
	}


	public  String getName()  {
	
		return "basic2Connector";
	
	}


	public  void setAdaptOnClasses(boolean bol)  {
	
		setAdaptOnClassesImpl(bol);
		ConnectorPersistance.saveConnector(this);
	
	}


	public  void setAdaptOnClassesImpl(boolean bol)  {
	
		isClassAdapter = bol;
		firePropertyChangeEvent(new HookPropertyChangeEvent(HookPropertyChangeEvent.IS_STATIC,new Boolean(bol)));
	
	}


	public  Enumeration getMethods()  {
	
		return methods.elements();
	
	}


	public  Hashtable getMethodHashtable(int i)  {
	
		return (Hashtable) methodHashtableVector.elementAt(i);
	
	}


	public  Hashtable getMethodHashtable(HookElement c)  {
	
		int pos = cutpoints.indexOf(c);
		return (Hashtable) methodHashtableVector.elementAt(pos);
	
	}


	public  int indexOf(HookElement c)  {
	
		return cutpoints.indexOf(c);
	
	}


	public  void setEnabled(boolean b)  {
	
		setEnabledImpl(b);
		ConnectorPersistance.saveConnector(this);
	
	}


	public  void setEnabledImpl(boolean b)  {
	
		isEnabled=b;
		firePropertyChangeEvent(new HookPropertyChangeEvent(HookPropertyChangeEvent.IS_ENABLED,new Boolean(b)));
	
	}


	public  void firePropertyChangeEvent(HookPropertyChangeEvent event)  {
	
		Enumeration i = getCutpoints();
		while(i.hasMoreElements()) {
			HookElement next = (HookElement) i.nextElement();
			next.globalPropertyChangeEvent(event);
		}
	
	}


	public  boolean isEnabled()  {
	
		return isEnabled;
	
	}


	public  boolean doNotCache()  {
	
		return doNotCache;
	
	}


	public  void setDoNotCache(boolean b)  {
	
		doNotCache=b;
	
	}


	public  Enumeration getCutpoints()  {
	
		return cutpoints.elements();
	
	}


	public  Enumeration getCombinationStrategies()  {
	
		return combinationStrategies.elements();
	
	}


	public  Enumeration getHooks()  {
	
		return getCutpoints();
	
	}


	public  Enumeration getInstances()  {
	
		return instances.elements();
	
	}


	public  String getFilename()  {
	
		return filename;
	
	}


	public  void setFilename(String filename)  {
	
		this.filename=filename;
	
	}


	public  int getPriority()  {
	
		return priority;
	
	}


	public  void setPriority(int p)  {
	
		this.priority=p;
		ConnectorRegistry.reOrderConnectors();
	
	}


	public final  tester_ExecuteHook temp()  {
	
		return temp;
	
	}


	public final  tester_CallHook temp2()  {
	
		return temp2;
	
	}


	public final  cflowClass_cflowtest temp3()  {
	
		return temp3;
	
	}


	public  Vector findCutpointForMethod(Object anInstance , MethodJoinpoint aJascoMethod , int startID , boolean forJutta)  {
	
		Vector results = new Vector();
		if(!isEnabled()) return results;
		if(!adaptOnClasses() && anInstance!=null && !instances.contains(anInstance)) {
			return results;
		}
		for (int i = 0; i < cutpoints.size() ; i++) { 
				HookElement element = (HookElement) cutpoints.elementAt(i);
				if(element.isApplicable(getMethodHashtable(i),aJascoMethod,forJutta))
					results.addElement(element.transformOrder(startID));
		}
		HookList hooks = new HookList(results);HookList returnlist = verifyCombinations(hooks);return returnlist.getCutpointElements();
	
	}


	protected static  void initAspects()  {
	
		myinstance.methods.clear();
		myinstance.combinationStrategies.clear();
		myinstance.cutpoints.clear();
		myinstance.methodHashtableVector.clear();
		//Java Code
		jasco.runtime.refinements.RefinementManager.getInstance().registerRefinement(new RefinableModuletemp(myinstance.temp));
		myinstance.temp._Jasco_setConnector(myinstance);
		myinstance.temp2._Jasco_setConnector(myinstance);
		myinstance.temp3._Jasco_setConnector(myinstance);
		{Hashtable methodHashtable=new Hashtable();
		Vector var0 = new Vector();
		MethodSignature var1 = MethodSignature.build("java.lang.String", "javax.swing.MyJButton", "*", new String[] {}, new String[] {},0);
		var0.add(var1);
		MethodSignature var2 = MethodSignature.build("java.lang.String", "*", "*", new String[] {"java.lang.String"}, new String[] {},0);
		var0.add(var2);
		ISignatureMatcher var3 = new CombinedMethodSignature(var0);
		methodHashtable.put("0", var3);
		Vector var4 = new Vector();
		MethodSignature var5 = MethodSignature.build("*", "javax.swing.MyJButton", "*", new String[] {"*"}, new String[] {},0);
		var4.add(var5);
		ISignatureMatcher var6 = new CombinedMethodSignature(var4);
		methodHashtable.put("1", var6);
		myinstance.cutpoints.addElement(myinstance.temp_cutpoint);
		myinstance.methodHashtableVector.addElement(methodHashtable);
		myinstance.methods.addElement(var3);
		}
		{Hashtable methodHashtable=new Hashtable();
		Vector var7 = new Vector();
		MethodSignature var8 = MethodSignature.build("void", "sunw.demo.juggler.Juggler", "startJuggling", new String[] {}, new String[] {},0);
		var7.add(var8);
		MethodSignature var9 = MethodSignature.build("void", "sunw.demo.juggler.Juggler", "stopJuggling", new String[] {}, new String[] {},0);
		var7.add(var9);
		MethodSignature var10 = MethodSignature.build("*", "javax.swing.MyJButton", "*", new String[] {}, new String[] {},0);
		var7.add(var10);
		ISignatureMatcher var11 = new CombinedMethodSignature(var7);
		methodHashtable.put("0", var11);
		myinstance.cutpoints.addElement(myinstance.temp2_cutpoint);
		myinstance.methodHashtableVector.addElement(methodHashtable);
		myinstance.methods.addElement(var11);
		}
		{Hashtable methodHashtable=new Hashtable();
		Vector var12 = new Vector();
		MethodSignature var13 = MethodSignature.build("*", "*", "*", new String[] {"*"}, new String[] {},0);
		var12.add(var13);
		ISignatureMatcher var14 = new CombinedMethodSignature(var12);
		methodHashtable.put("0", var14);
		Vector var15 = new Vector();
		MethodSignature var16 = MethodSignature.build("*", "*", "main", new String[] {"java.lang.String[]"}, new String[] {},0);
		var15.add(var16);
		ISignatureMatcher var17 = new CombinedMethodSignature(var15);
		methodHashtable.put("1", var17);
		myinstance.cutpoints.addElement(myinstance.temp3_cutpoint);
		myinstance.methodHashtableVector.addElement(methodHashtable);
		myinstance.methods.addElement(var14);
		}
	
	}


	public static  void load(String filename)  {
	
		synchronized(myinstance) {getConnector().setFilename(filename);
		initAspects();
		ConnectorRegistry.registerConnector(myinstance);
		myinstance.firePropertyChangeEvent(new HookPropertyChangeEvent(HookPropertyChangeEvent.IS_ADDED));
		}
	
	}


	protected  HookList verifyCombinations(HookList hooks)  {
	
		Enumeration combinations = combinationStrategies.elements();
		while(combinations.hasMoreElements()) {
			CombinationStrategy strategy = (CombinationStrategy) combinations.nextElement();
			hooks=strategy.validateCombinations(hooks);
		}
		return hooks;
	
	}


	
	
	public static class RefinableModuletemp  extends jasco.runtime.refinements.ConnectorInlineRefinement  {
	
		static Vector theImplementedMethods = new Vector();
	
	
		static {
	
		theImplementedMethods.add("test");
		theImplementedMethods.add("test22");
		theImplementedMethods.add("testBoeps22");
		}
	
		  RefinableModuletemp(jasco.runtime.aspect.IHook hook)  {
		
			super(hook,theImplementedMethods);
		
		}
	
	
		 public  void test(jasco.runtime.aspect.IHook thisHook_JasCo_2 , jasco.runtime.MethodJoinpoint thisJoinPoint)  //13
		 {
		
			Object thisJoinPointObject = thisJoinPoint.getCalledObject();
			test.basic.tester_ExecuteHook thisHook = (test.basic.tester_ExecuteHook)thisHook_JasCo_2;
			test.basic.tester_ExecuteHook temp = (test.basic.tester_ExecuteHook)thisHook_JasCo_2;
			System. out. println ( "boeps" ) ; //14
			//15
		
		} //13
	
	
		 public  javax.swing.JFrame test22(jasco.runtime.aspect.IHook thisHook_JasCo_2 , jasco.runtime.MethodJoinpoint thisJoinPoint , java.lang.String test)  //16
		 {
		
			Object thisJoinPointObject = thisJoinPoint.getCalledObject();
			test.basic.tester_ExecuteHook thisHook = (test.basic.tester_ExecuteHook)thisHook_JasCo_2;
			test.basic.tester_ExecuteHook temp = (test.basic.tester_ExecuteHook)thisHook_JasCo_2;
			System. out. println ( test + temp ) ; //17
			return new javax. swing. JFrame ( ) ; //18
			//19
		
		} //16
	
	
		 public  void testBoeps22(jasco.runtime.aspect.IHook thisHook_JasCo_2 , jasco.runtime.MethodJoinpoint thisJoinPoint , java.lang.String test)  //20
		 {
		
			Object thisJoinPointObject = thisJoinPoint.getCalledObject();
			test.basic.tester_ExecuteHook thisHook = (test.basic.tester_ExecuteHook)thisHook_JasCo_2;
			test.basic.tester_ExecuteHook temp = (test.basic.tester_ExecuteHook)thisHook_JasCo_2;
			System. out. println ( test + temp ) ; //21
		
		} //20
	
	
	
	}

}