package test.stateful;

import java.lang.*;
import java.util.*;
import java.lang.reflect.*;
import jasco.runtime.aspect.*;
import jasco.runtime.connector.*;
import jasco.runtime.*;
import jasco.util.logging.*;
import jasco.runtime.refinements.*;
import test.stateful.*; //1

@jasco.runtime.aspect.annotation.AnnotationsSupported  
public class StatefulControlFlow_TestHook  implements IHook, jasco.runtime.aspect.StatefulAspect {

	protected jasco.runtime.MethodJoinpoint _Jasco_temp_thisJoinPoint;

	private String _Jasco_cutpointname;

	private Connector _Jasco_connector;

	private PCutpointConstructorApplicationDesignator _Jasco_cutpointconstructorRepLocal;

	public static final PCutpointConstructorApplicationDesignator _Jasco_cutpointconstructorRep;

	private int _Jasco_statefulAspectState;

	public static final ConstructorMethod[] _Jasco_constructorArgs = new ConstructorMethod[3];

	protected Object[] args;

	public static final boolean _Jasco_hasBefore = true;

	public static final boolean _Jasco_hasAfter = true;

	protected StatefulControlFlow global;


	static {

	_Jasco_constructorArgs[0]= new ConstructorMethod(null, new Class[] {}, new String[] {"args"}, true);
	_Jasco_constructorArgs[1]= new ConstructorMethod(null, new Class[] {}, new String[] {"args"}, true);
	_Jasco_constructorArgs[2]= new ConstructorMethod(null, new Class[] {}, new String[] {"args"}, true);
	}
	static {

	_Jasco_cutpointconstructorRep=_Jasco_cutpointconstructorRepInit();
	}

	protected  Object mixinOf(Object target , Class mixin) throws jasco.runtime.mixin.NoMixinFound {
	
		return jasco.runtime.mixin.MixinManager.getInstance().mixinOf(target,mixin);
	
	}


	public  Object _Jasco_getGlobal()  {
	
		return global;
	
	}


	public  void _Jasco_setGlobal(StatefulControlFlow aGlobal)  {
	
		global=aGlobal;
	
	}


	public   StatefulControlFlow_TestHook(StatefulControlFlow aGlobal)  {
	
		global=aGlobal;
		this._Jasco_cutpointconstructorRepLocal=_Jasco_cutpointconstructorRepInit();
	
	}


	public   StatefulControlFlow_TestHook()  {
	
		 this._Jasco_cutpointconstructorRepLocal=_Jasco_cutpointconstructorRepInit();
	
	}


	public  PCutpointConstructorApplicationDesignator _Jasco_getConstructorRep()  {
	
		return _Jasco_cutpointconstructorRepLocal;
	
	}


	public  int _jasco_setStatefulAspectState(int newState)  {
	
		int tmp=_Jasco_statefulAspectState;this._Jasco_statefulAspectState=newState;return tmp;
	
	}


	public  int _jasco_getStatefulAspectState()  {
	
		return _Jasco_statefulAspectState;
	
	}


	public static  PCutpointConstructorApplicationDesignator _Jasco_cutpointconstructorRepInit()  {
	
		PCutpointConstructorApplicationDesignator myrep = null;
		PCutpointConstructorRegular arg0 = null;
		arg0 = new PCutpointConstructorRegular();
		myrep = arg0;
		State START = new State("START", 10);
		arg0.setStartState(START);
		State ATrans = new State("ATrans", 11);
		arg0.addState(ATrans);
		State BTrans = new State("BTrans", 12);
		arg0.addState(BTrans);
		State CTrans = new State("CTrans", 13);
		arg0.addState(CTrans);
		PCutpointConstructorApplicationDesignator arg1 = null;
		PCutpointConstructorApplicationDesignator arg2, arg3;
		arg2 = new PCutpointConstructorArgs(_Jasco_constructorArgs[0], 0);
		arg3 = new PCutpointConstructorExecute("0", false);
		arg1 = new PCutpointConstructorAnd(arg2, arg3);
		arg0.addTransition(START, 1, arg1, ATrans);
		PCutpointConstructorApplicationDesignator arg4 = null;
		PCutpointConstructorApplicationDesignator arg5, arg6;
		arg5 = new PCutpointConstructorArgs(_Jasco_constructorArgs[1], 1);
		arg6 = new PCutpointConstructorExecute("1", false);
		arg4 = new PCutpointConstructorAnd(arg5, arg6);
		arg0.addTransition(ATrans, 2, arg4, BTrans);
		PCutpointConstructorApplicationDesignator arg7 = null;
		PCutpointConstructorApplicationDesignator arg8, arg9;
		arg8 = new PCutpointConstructorArgs(_Jasco_constructorArgs[2], 2);
		arg9 = new PCutpointConstructorExecute("2", false);
		arg7 = new PCutpointConstructorAnd(arg8, arg9);
		arg0.addTransition(BTrans, 3, arg7, CTrans);
		arg0.addTransition(CTrans, 1, arg1, ATrans);
		return myrep;
	
	}


	public  void _Jasco_setCutpointName(String aCutpointName)  {
	
		_Jasco_cutpointname = aCutpointName;
	
	}


	public  String _Jasco_getCutpointName()  {
	
		return _Jasco_cutpointname;
	
	}


	public  void _Jasco_setConnector(Connector aConnector)  {
	
		_Jasco_connector = aConnector;
	
	}


	public  Connector _Jasco_getConnector()  {
	
		return _Jasco_connector;
	
	}


	@jasco.runtime.aspect.annotation.Advice(type="before_ATrans") public  void before_ATrans(jasco.runtime.MethodJoinpoint thisJoinPoint , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception //15
	 {
	
		System. out. println ( "Before Atrans: " + thisJoinPoint ) ;  //17
		 //18
	
	} //15


	@jasco.runtime.aspect.annotation.Advice(type="before_BTrans") public  void before_BTrans(jasco.runtime.MethodJoinpoint thisJoinPoint , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception //25
	 {
	
		System. out. println ( "Before Btrans: " + thisJoinPoint ) ;  //27
		 //28
	
	} //25


	@jasco.runtime.aspect.annotation.Advice(type="before_CTrans") public  void before_CTrans(jasco.runtime.MethodJoinpoint thisJoinPoint , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception //35
	 {
	
		System. out. println ( "Before Ctrans: " + thisJoinPoint ) ;  //37
		 //38
	
	} //35


	public  void before(jasco.runtime.MethodJoinpoint thisJoinPoint , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception {
	
		int currentStateID = _jasco_getStatefulAspectState();
		switch(currentStateID) {
		case 11 :
			before_ATrans(thisJoinPoint, _JAsCo_Dummy_634353);return;
		case 12 :
			before_BTrans(thisJoinPoint, _JAsCo_Dummy_634353);return;
		case 13 :
			before_CTrans(thisJoinPoint, _JAsCo_Dummy_634353);return;
		default: 
		 ;}
	
	}


	@jasco.runtime.aspect.annotation.Advice(type="after_ATrans") public  void after_ATrans(jasco.runtime.MethodJoinpoint thisJoinPoint , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception //20
	 {
	
		System. out. println ( "After Atrans: " + thisJoinPoint ) ;  //22
		 //23
	
	} //20


	@jasco.runtime.aspect.annotation.Advice(type="after_BTrans") public  void after_BTrans(jasco.runtime.MethodJoinpoint thisJoinPoint , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception //30
	 {
	
		System. out. println ( "After Btrans: " + thisJoinPoint ) ;  //32
		 //33
	
	} //30


	@jasco.runtime.aspect.annotation.Advice(type="after_CTrans") public  void after_CTrans(jasco.runtime.MethodJoinpoint thisJoinPoint , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception //40
	 {
	
		System. out. println ( "After Ctrans: " + thisJoinPoint ) ;  //42
		 //43
	
	} //40


	public  void after(jasco.runtime.MethodJoinpoint thisJoinPoint , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception {
	
		int currentStateID = _jasco_getStatefulAspectState();
		switch(currentStateID) {
		case 11 :
			after_ATrans(thisJoinPoint, _JAsCo_Dummy_634353);return;
		case 12 :
			after_BTrans(thisJoinPoint, _JAsCo_Dummy_634353);return;
		case 13 :
			after_CTrans(thisJoinPoint, _JAsCo_Dummy_634353);return;
		default: 
		 ;}
	
	}


	public  Object around(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception {
	
		return proceed(thisJoinPoint);
	
	}


	public  void after_throwing(Object arg , jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		 ;
	
	}


	public  void after_returning(Object arg , jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		 ;
	
	}


	public  Object around_throwing(Object arg , jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		throw (Exception) arg;
	
	}


	public  Object around_returning(Object arg , jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		return arg ;
	
	}


	public  boolean isApplicable(jasco.runtime.MethodJoinpoint thisJoinPoint , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353)  {
	
		return true;
	
	}


	public  HookContextProperty _Jasco_getHookContextPropertyForAdvice(String advice)  {
	
		return _Jasco_getHookContextPropertyForAdvicetest_stateful_StatefulControlFlow_TestHook(advice, new jasco.runtime.aspect.HookContextProperty(true, false, false, true, true, true));
	
	}


	public  HookContextProperty _Jasco_getHookContextPropertyForAdvicetest_stateful_StatefulControlFlow_TestHook(String advice , HookContextProperty thisProperty)  {
	
		if (advice.equals(HookContextProperty.GLOBAL)) return thisProperty;
		else if (advice.equals("before_ATrans")) return thisProperty;
		else if (advice.equals("before_BTrans")) return thisProperty;
		else if (advice.equals("before_CTrans")) return thisProperty;
		else if (advice.equals("before")) return thisProperty;
		else if (advice.equals("after_ATrans")) return thisProperty;
		else if (advice.equals("after_BTrans")) return thisProperty;
		else if (advice.equals("after_CTrans")) return thisProperty;
		else if (advice.equals("after")) return thisProperty;
		else if (advice.equals("around")) return thisProperty;
		else if (advice.equals("isApplicable")) return thisProperty;
		else return null;
	
	}


	public  void before_ATrans(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		before_ATrans(thisJoinPoint, (Dummy)null);
	
	}


	public  void before_BTrans(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		before_BTrans(thisJoinPoint, (Dummy)null);
	
	}


	public  void before_CTrans(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		before_CTrans(thisJoinPoint, (Dummy)null);
	
	}


	public  void before(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		before(thisJoinPoint, (Dummy)null);
	
	}


	public  void after_ATrans(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		after_ATrans(thisJoinPoint, (Dummy)null);
	
	}


	public  void after_BTrans(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		after_BTrans(thisJoinPoint, (Dummy)null);
	
	}


	public  void after_CTrans(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		after_CTrans(thisJoinPoint, (Dummy)null);
	
	}


	public  void after(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		after(thisJoinPoint, (Dummy)null);
	
	}


	public  Object around(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		return around(thisJoinPoint, thisJoinPointObject, (Dummy)null);
	
	}


	public  boolean isApplicable(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args)  {
	
		return isApplicable(thisJoinPoint, (Dummy)null);
	
	}


	public final  Object proceed(jasco.runtime.MethodJoinpoint calledmethod) throws java.lang.Exception {
	
		Object result = calledmethod.invokeJAsCoMethod();return result;
	
	}


	public final  Object proceed(jasco.runtime.MethodJoinpoint calledmethod , Object obj , Object[] args) throws java.lang.Exception {
	
		Object result = calledmethod.invoke(obj,args);return result;
	
	}


	public  Object proceed(jasco.runtime.MethodJoinpoint thisJoinPoint , Object[] var0) throws java.lang.Exception {
	
		Object[] _newArgs = new Object[0+var0.length];
		for(int j=0;j<var0.length;++j)
			_newArgs[0+j] = var0[j];
		Object result = thisJoinPoint.invoke(thisJoinPoint.getCalledObject(),_newArgs);
		return result;
	
	}


	public  void globalPropertyChangeEvent(HookPropertyChangeEvent event)  {
	
		 
	
	}


	public static  java.util.Map _Jasco_getTriggeringBinding(jasco.runtime.MethodJoinpoint thisJoinPoint)  {
	
		Object[] args = thisJoinPoint.getArgumentsArray();
		java.util.Hashtable bindings = new java.util.Hashtable();
		return bindings;
	
	}



}