// $Id: ReplicationException.java,v 1.5 2006/12/11 21:14:34 genman Exp $

/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

package org.jboss.cache;

/**
 * Thrown when a replication problem occurred
 */
public class ReplicationException extends CacheException
{

   private static final long serialVersionUID = 33172388691879866L;

   public ReplicationException()
   {
      super();
   }

   public ReplicationException(Throwable cause)
   {
      super(cause);
   }

   public ReplicationException(String msg)
   {
      super(msg);
   }

   public ReplicationException(String msg, Throwable cause)
   {
      super(msg, cause);
   }

   public String toString()
   {
      return super.toString();
   }
}
