package org.jboss.cache;

/**
 * Thrown when a member is suspected during remote method invocation
 * @author Bela Ban
 * @version $Id: SuspectException.java,v 1.2 2006/12/11 21:14:34 genman Exp $
 */
public class SuspectException extends CacheException
{

   private static final long serialVersionUID = -2965599037371850141L;

   public SuspectException() {
      super();
   }

   public SuspectException(String msg) {
      super(msg);
   }

   public SuspectException(String msg, Throwable cause) {
      super(msg, cause);
   }

   public String toString() {
      return super.toString();
   }
}
