package jasco.runtime.aspect.factory;

import jasco.runtime.DoNotCache;
import jasco.runtime.MethodJoinpoint;

public class PerFirstArgAspectFactory extends WeakReferenceAspectFactory implements DoNotCache  {

	@Override
	public Object getKey(MethodJoinpoint jp) {
		
		Object[] args = jp.getArgumentsArray();
		if(args==null) return null;
		for(int i=0;i<args.length;++i)
			if(args[i] instanceof Object)
				return args[i];
		
		return null;
	}

}
