package jasco.runtime.distribution;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

public class DefaultSharedField extends UnicastRemoteObject implements ISharedField {
	
	private IRemoteSharedField value;
	
	public DefaultSharedField(Object value) throws RemoteException {
		super();
		this.value=new RemoteSharedField(value);
	}
 
	public Object getValue() throws RemoteException {
		return value.getValue();
	}

	public void setValue(Object value) throws RemoteException {
		this.value.setValue(value);
	}
}
