package jasco.runtime.distribution;

import jasco.runtime.Advice.Type;

import java.io.Serializable;

public class DistributedAdviceExecution implements Serializable {

	private jasco.runtime.Advice.Type adviceType; 
	private Host host;
	private DistributedJascoMethod jp;
	private String connectorClassName;
	private String aspectInstanceName;
	
	public DistributedAdviceExecution(Type type, String name, String name2, Host host, DistributedJascoMethod jp) {
		super();
		
		adviceType = type;
		aspectInstanceName = name;
		connectorClassName = name2;
		this.host = host;
		this.jp = jp;
	}

	public jasco.runtime.Advice.Type getAdviceType() {
		return adviceType;
	}

	public String getAspectInstanceName() {
		return aspectInstanceName;
	}

	public String getConnectorClassName() {
		return connectorClassName;
	}

	public Host getHost() {
		return host;
	}

	public DistributedJascoMethod getJP() {
		return jp;
	}
	

}
