package jasco.runtime.distribution.causality;

import org.jgroups.protocols.TransportedVectorTime;


public class ThreadVectorClock {


	private static ThreadLocal<TransportedVectorTime> currentClock = new ThreadLocal<TransportedVectorTime>();
	
	public static TransportedVectorTime getVectorClock() {
		return currentClock.get();
	}
	
	public static void setRemoteInfo(TransportedVectorTime vectorClock) {
		currentClock.set(vectorClock);
	}
	
}
