package jasco.util.distribution;

import java.io.IOException;
import java.net.ServerSocket;
import java.rmi.server.RMIServerSocketFactory;

/**
 * @author lbenavid
 * 
 */
public class JascoServerSocketFactory implements RMIServerSocketFactory {

	public JascoServerSocketFactory() {
	}
	
    public boolean equals(Object obj) {
        return getClass() == obj.getClass();
    }

    public int hashCode() {
        return getClass().hashCode();
    }

    public ServerSocket createServerSocket(int port) throws IOException {
    	return new JascoServerSocket(port);
    }
}
