package Connector;

import java.lang.*;
import java.util.*;
import jasco.runtime.aspect.*;
import jasco.runtime.connector.*;
import jasco.runtime.*;
import test.basic.*;


public class TargetConnector  implements Connector {

	private Vector methods = new Vector();

	private Vector combinationStrategies = new Vector();

	private Vector instances = new Vector();

	private static TargetConnector myinstance = new TargetConnector();

	private boolean isClassAdapter = true;

	private boolean isEnabled = true;

	private boolean doNotCache = false;

	private Vector cutpoints = new Vector();

	private Vector methodHashtableVector = new Vector();

	private String filename;

	private int priority;

	public final test.basic.TargetTest TargetTest = new test.basic.TargetTest();

	public final TargetTest_TargetHook temp2 = new test.basic.TargetTest_TargetHook(TargetTest);

	private HookElement temp2_cutpoint = new HookElement (temp2, new CutpointExecutionElement(false,-1), new CutpointExecutionElement(true,0), new CutpointExecutionElement(false,-1), "temp2");


	static {

	myinstance.temp2._Jasco_setCutpointName("temp2");
	}

	private static  void addCombinationStrategy(CombinationStrategy aStrategy)  {
	
		myinstance.combinationStrategies.addElement(aStrategy);
	
	}


	public  void addInstance(Object object)  {
	
		instances.addElement(object);
	
	}


	public  void removeInstance(Object object)  {
	
		instances.removeElement(object);
	
	}


	public static  TargetConnector getConnector()  {
	
		return myinstance;
	
	}


	public  boolean adaptOnClasses()  {
	
		return isClassAdapter;
	
	}


	public  String getName()  {
	
		return "TargetConnector";
	
	}


	public  void setAdaptOnClasses(boolean bol)  {
	
		setAdaptOnClassesImpl(bol);
		ConnectorPersistance.saveConnector(this);
	
	}


	public  void setAdaptOnClassesImpl(boolean bol)  {
	
		isClassAdapter = bol;
		firePropertyChangeEvent(new HookPropertyChangeEvent(HookPropertyChangeEvent.IS_STATIC,new Boolean(bol)));
	
	}


	public  Enumeration getMethods()  {
	
		return methods.elements();
	
	}


	public  Hashtable getMethodHashtable(int i)  {
	
		return (Hashtable) methodHashtableVector.elementAt(i);
	
	}


	public  Hashtable getMethodHashtable(HookElement c)  {
	
		int pos = cutpoints.indexOf(c);
		return (Hashtable) methodHashtableVector.elementAt(pos);
	
	}


	public  int indexOf(HookElement c)  {
	
		return cutpoints.indexOf(c);
	
	}


	public  void setEnabled(boolean b)  {
	
		setEnabledImpl(b);
		ConnectorPersistance.saveConnector(this);
	
	}


	public  void setEnabledImpl(boolean b)  {
	
		isEnabled=b;
		firePropertyChangeEvent(new HookPropertyChangeEvent(HookPropertyChangeEvent.IS_ENABLED,new Boolean(b)));
	
	}


	public  void firePropertyChangeEvent(HookPropertyChangeEvent event)  {
	
		Enumeration i = getCutpoints();
		while(i.hasMoreElements()) {
			HookElement next = (HookElement) i.nextElement();
			next.globalPropertyChangeEvent(event);
		}
	
	}


	public  boolean isEnabled()  {
	
		return isEnabled;
	
	}


	public  boolean doNotCache()  {
	
		return doNotCache;
	
	}


	public  void setDoNotCache(boolean b)  {
	
		doNotCache=b;
	
	}


	public  Enumeration getCutpoints()  {
	
		return cutpoints.elements();
	
	}


	public  Enumeration getCombinationStrategies()  {
	
		return combinationStrategies.elements();
	
	}


	public  Enumeration getHooks()  {
	
		return getCutpoints();
	
	}


	public  Enumeration getInstances()  {
	
		return instances.elements();
	
	}


	public  String getFilename()  {
	
		return filename;
	
	}


	public  void setFilename(String filename)  {
	
		this.filename=filename;
	
	}


	public  int getPriority()  {
	
		return priority;
	
	}


	public  void setPriority(int p)  {
	
		this.priority=p;
		ConnectorRegistry.reOrderConnectors();
	
	}


	public final  TargetTest_TargetHook temp2()  {
	
		return temp2;
	
	}


	public  Vector findCutpointForMethod(Object anInstance , MethodJoinpoint aJascoMethod , int startID , boolean forJutta)  {
	
		Vector results = new Vector();
		if(!isEnabled()) return results;
		if(!adaptOnClasses() && anInstance!=null && !instances.contains(anInstance)) {
			return results;
		}
		for (int i = 0; i < cutpoints.size() ; i++) { 
				HookElement element = (HookElement) cutpoints.elementAt(i);
				if(element.isApplicable(getMethodHashtable(i),aJascoMethod,forJutta))
					results.addElement(element.transformOrder(startID));
		}
		HookList hooks = new HookList(results);HookList returnlist = verifyCombinations(hooks);return returnlist.getCutpointElements();
	
	}


	protected static  void initAspects()  {
	
		myinstance.methods.clear();
		myinstance.combinationStrategies.clear();
		myinstance.cutpoints.clear();
		myinstance.methodHashtableVector.clear();
		//Java Code
		myinstance.temp2._Jasco_setConnector(myinstance);
		{Hashtable methodHashtable=new Hashtable();
		Vector var0 = new Vector();
		MethodSignature var1 = MethodSignature.build("*", "*", "*", new String[] {"*"}, new String[] {},0);
		var0.add(var1);
		ISignatureMatcher var2 = new CombinedMethodSignature(var0);
		methodHashtable.put("0", var2);
		myinstance.cutpoints.addElement(myinstance.temp2_cutpoint);
		myinstance.methodHashtableVector.addElement(methodHashtable);
		myinstance.methods.addElement(var2);
		}
	
	}


	public static  void load(String filename)  {
	
		synchronized(myinstance) {getConnector().setFilename(filename);
		initAspects();
		ConnectorRegistry.registerConnector(myinstance);
		myinstance.firePropertyChangeEvent(new HookPropertyChangeEvent(HookPropertyChangeEvent.IS_ADDED));
		}
	
	}


	protected  HookList verifyCombinations(HookList hooks)  {
	
		Enumeration combinations = combinationStrategies.elements();
		while(combinations.hasMoreElements()) {
			CombinationStrategy strategy = (CombinationStrategy) combinations.nextElement();
			hooks=strategy.validateCombinations(hooks);
		}
		return hooks;
	
	}



}