package test.mixin;

import java.lang.*;
import java.util.*;
import java.lang.reflect.*;
import jasco.runtime.aspect.*;
import jasco.runtime.connector.*;
import jasco.runtime.*;
import jasco.util.logging.*;
import jasco.runtime.refinements.*;
import test.mixin.IGetID; //3
import test.mixin.*; //1

@jasco.runtime.aspect.annotation.AnnotationsSupported  
public class MixinTest_Use  implements IHook {

	protected jasco.runtime.MethodJoinpoint _Jasco_temp_thisJoinPoint;

	private String _Jasco_cutpointname;

	private Connector _Jasco_connector;

	public static final PCutpointConstructorApplicationDesignator _Jasco_cutpointconstructorRep;

	public static final ConstructorMethod[] _Jasco_constructorArgs = new ConstructorMethod[1];

	protected Object[] args;

	public static final boolean _Jasco_hasBefore = true;

	public static final boolean _Jasco_hasAfter = true;

	protected MixinTest global;


	static {

	_Jasco_constructorArgs[0]= new ConstructorMethod(null, new Class[] {}, new String[] {"args"}, true);
	}
	static {

	_Jasco_cutpointconstructorRep=_Jasco_cutpointconstructorRepInit();
	}

	protected  Object mixinOf(Object target , Class mixin) throws jasco.runtime.mixin.NoMixinFound {
	
		return jasco.runtime.mixin.MixinManager.getInstance().mixinOf(target,mixin);
	
	}


	public  Object _Jasco_getGlobal()  {
	
		return global;
	
	}


	public  void _Jasco_setGlobal(MixinTest aGlobal)  {
	
		global=aGlobal;
	
	}


	public   MixinTest_Use(MixinTest aGlobal)  {
	
		global=aGlobal;
	
	}


	public   MixinTest_Use()  {
	
		 
	
	}


	public  PCutpointConstructorApplicationDesignator _Jasco_getConstructorRep()  {
	
		return _Jasco_cutpointconstructorRep;
	
	}


	public static  PCutpointConstructorApplicationDesignator _Jasco_cutpointconstructorRepInit()  {
	
		PCutpointConstructorApplicationDesignator myrep = null;
		PCutpointConstructorApplicationDesignator arg2, arg3;
		arg2 = new PCutpointConstructorArgs(_Jasco_constructorArgs[0], 0);
		arg3 = new PCutpointConstructorExecute("0", false);
		myrep = new PCutpointConstructorAnd(arg2, arg3);
		return myrep;
	
	}


	public  void _Jasco_setCutpointName(String aCutpointName)  {
	
		_Jasco_cutpointname = aCutpointName;
	
	}


	public  String _Jasco_getCutpointName()  {
	
		return _Jasco_cutpointname;
	
	}


	public  void _Jasco_setConnector(Connector aConnector)  {
	
		_Jasco_connector = aConnector;
	
	}


	public  Connector _Jasco_getConnector()  {
	
		return _Jasco_connector;
	
	}


	@jasco.runtime.aspect.annotation.Advice(type="before") public  void before(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception //27
	 {
	
		try {  //28
		IGetID mixin = ( IGetID ) mixinOf ( thisJoinPointObject, IGetID. class ) ;  //29
		System. out. println ( "before:" + mixin. getTestID ( ) ) ;  //30
		} catch ( jasco. runtime. mixin. NoMixinFound ex ) { System. err. println ( "no mixin found" ) ; ex. printStackTrace ( ) ;  //32
		}  //33
		 //34
	
	} //27


	@jasco.runtime.aspect.annotation.Advice(type="after") public  void after(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception //36
	 {
	
		try {  //37
		IGetID mixin = ( IGetID ) thisJoinPointObject ;  //39
		System. out. println ( "after:" + mixin. getTestID ( ) ) ;  //40
		} catch ( jasco. runtime. mixin. NoMixinFound ex ) { System. err. println ( "no mixin found" ) ; ex. printStackTrace ( ) ;  //42
		}  //43
		 //44
	
	} //36


	public  Object around(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353) throws java.lang.Exception {
	
		return proceed(thisJoinPoint);
	
	}


	public  void after_throwing(Object arg , jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		 ;
	
	}


	public  void after_returning(Object arg , jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		 ;
	
	}


	public  Object around_throwing(Object arg , jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		throw (Exception) arg;
	
	}


	public  Object around_returning(Object arg , jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		return arg ;
	
	}


	public  boolean isApplicable(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , jasco.runtime.aspect.Dummy _JAsCo_Dummy_634353)  {
	
		return true;
	
	}


	public  HookContextProperty _Jasco_getHookContextPropertyForAdvice(String advice)  {
	
		return _Jasco_getHookContextPropertyForAdvicetest_mixin_MixinTest_Use(advice, new jasco.runtime.aspect.HookContextProperty(true, false, true, true, true, true));
	
	}


	public  HookContextProperty _Jasco_getHookContextPropertyForAdvicetest_mixin_MixinTest_Use(String advice , HookContextProperty thisProperty)  {
	
		if (advice.equals(HookContextProperty.GLOBAL)) return thisProperty;
		else if (advice.equals("before")) return thisProperty;
		else if (advice.equals("after")) return thisProperty;
		else if (advice.equals("around")) return thisProperty;
		else if (advice.equals("isApplicable")) return thisProperty;
		else return null;
	
	}


	public  void before(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		before(thisJoinPoint, thisJoinPointObject, (Dummy)null);
	
	}


	public  void after(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		after(thisJoinPoint, thisJoinPointObject, (Dummy)null);
	
	}


	public  Object around(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args) throws java.lang.Exception {
	
		return around(thisJoinPoint, thisJoinPointObject, (Dummy)null);
	
	}


	public  boolean isApplicable(jasco.runtime.MethodJoinpoint thisJoinPoint , Object thisJoinPointObject , Object[] args)  {
	
		return isApplicable(thisJoinPoint, thisJoinPointObject, (Dummy)null);
	
	}


	public final  Object proceed(jasco.runtime.MethodJoinpoint calledmethod) throws java.lang.Exception {
	
		Object result = calledmethod.invokeJAsCoMethod();return result;
	
	}


	public final  Object proceed(jasco.runtime.MethodJoinpoint calledmethod , Object obj , Object[] args) throws java.lang.Exception {
	
		Object result = calledmethod.invoke(obj,args);return result;
	
	}


	public  Object proceed(jasco.runtime.MethodJoinpoint thisJoinPoint , Object[] var0) throws java.lang.Exception {
	
		Object[] _newArgs = new Object[0+var0.length];
		for(int j=0;j<var0.length;++j)
			_newArgs[0+j] = var0[j];
		Object result = thisJoinPoint.invoke(thisJoinPoint.getCalledObject(),_newArgs);
		return result;
	
	}


	public  void globalPropertyChangeEvent(HookPropertyChangeEvent event)  {
	
		 
	
	}


	public static  java.util.Map _Jasco_getTriggeringBinding(jasco.runtime.MethodJoinpoint thisJoinPoint)  {
	
		Object[] args = thisJoinPoint.getArgumentsArray();
		java.util.Hashtable bindings = new java.util.Hashtable();
		return bindings;
	
	}



}