package test.trav;

import edu.neu.ccs.demeter.dj.*;
import java.util.*;
import jasco.runtime.aspect.*;
import jasco.runtime.connector.*;
import jasco.runtime.connector.traversal.*;
import jasco.runtime.*;
import java.lang.reflect.*;
import test.trav.example.*;
import test.basic.*;


public class TestTraversal  implements jasco.runtime.connector.traversal.Traversal {

	private static TestTraversal instance = new TestTraversal();

	private Vector strategies = new Vector();

	private Hashtable beforeWrappers;

	private Hashtable afterWrappers;

	private Hashtable aroundWrappers;

	private Vector registry;



	public static  TestTraversal getTraversal()  {
	
		return instance;
	
	}


	public static  TestTraversal getInstance()  {
	
		return instance;
	
	}


	private   TestTraversal()  {
	
		 
	
	}


	public  Iterator getHooks()  {
	
		 return registry.iterator();
	
	}


	public  void traverse(Object startObject) throws Throwable {
	
		try{
		strategies=new Vector();
		aroundWrappers=new Hashtable();
		beforeWrappers=new Hashtable();
		afterWrappers=new Hashtable();
		registry=new Vector();
		
		test.basic.basic tempAspectBean = new test.basic.basic();
		test.basic.basic_easy temp = new test.basic.basic_easy(tempAspectBean);
		temp._Jasco_setCutpointName("temp");
		registry.add(temp);
		beforeWrappers.put(temp, new TraversalHookWrapper("*", temp, "temp", 10));
		afterWrappers.put(temp, new TraversalHookWrapper("*", temp, "temp", 13));
		test.basic.basic temp2AspectBean = new test.basic.basic();
		test.basic.basic_easy temp2 = new test.basic.basic_easy(temp2AspectBean);
		temp2._Jasco_setCutpointName("temp2");
		registry.add(temp2);
		beforeWrappers.put(temp2, new TraversalHookWrapper("test.trav.example.D", temp2, "temp2", 11));
		afterWrappers.put(temp2, new TraversalHookWrapper("test.trav.example.D", temp2, "temp2", 14));
		temp2.setPrintString ( "ONLY" ) ;//20
		ClassGraph cg = new ClassGraph();
		cg.addPackage("test.trav.example");
		cg.addPackage("test.basic");
		addCombinationStrategy ( new ExcludeCombinationStrategy ( temp2 , temp ) ) ;//22
		Strategy sg = new Strategy("from test.trav.example.A to test.trav.example.D");
		TraversalGraph tg = new TraversalGraph(sg, cg);
		tg.traverse(startObject,new AdaptiveVisitor(temp, temp2));
		}catch(VisitorMethodException ex) {if(ex.getException() instanceof JAsCoStopTraversal) ; else throw ex.getException();}
	
	}


	public  TraversalJascoMethod tempJascoMethod(Object context)  {
	
		TraversalJascoMethod tempJascomethod = null;
		try {Class contextclass = context.getClass();
		tempJascomethod = new TraversalJascoMethod(context,"visiting traversal node",contextclass.getName());
		}catch (Exception ex) {System.err.println(ex.getMessage());ex.printStackTrace();}
		return tempJascomethod;
	
	}


	public  TraversalJascoMethod temp2JascoMethod(Object context)  {
	
		TraversalJascoMethod temp2Jascomethod = null;
		try {Class contextclass = context.getClass();
		temp2Jascomethod = new TraversalJascoMethod(context,"visiting traversal node",contextclass.getName());
		}catch (Exception ex) {System.err.println(ex.getMessage());ex.printStackTrace();}
		return temp2Jascomethod;
	
	}


	protected  void addCombinationStrategy(CombinationStrategy strat)  {
	
		strategies.add(strat);
	
	}


	protected  HookList filterHooks(HookList _JascoHooks)  {
	
		Iterator combinations = strategies.iterator();
		while(combinations.hasNext()) {
			CombinationStrategy strategy = (CombinationStrategy) combinations.next();
			_JascoHooks=strategy.validateCombinations(_JascoHooks);
		}
		return _JascoHooks;
	
	}


	public  TraversalJascoMethod getJascoMethod(TraversalHookWrapper wrapper , Object context)  {
	
		try{Class cl = getClass();
		Class[] args = new Class[] {Class.forName("java.lang.Object")};
		Method method = cl.getMethod(wrapper.getVarName()+"JascoMethod",args);
		return (TraversalJascoMethod) method.invoke(this,new Object[] {context});
		}catch (Exception ex) {System.err.println(ex.getMessage());ex.printStackTrace();}
		return null;
	
	}


	
	
	class AdaptiveVisitor  extends Visitor  {
	
		private IHook temp;
	
		private IHook temp2;
	
	
	
		public  void start()  {
		
			 
		
		}
	
	
		public  void finish()  {
		
			 
		
		}
	
	
		public   AdaptiveVisitor(IHook temp , IHook temp2)  {
		
			this.temp=temp;this.temp2=temp2;
		
		}
	
	
		public  void before(Object context) throws JAsCoStopTraversal {
		
			try{Vector temphooks = new Vector();
			Iterator _JascoHooksI = registry.iterator();
			while(_JascoHooksI.hasNext()) {
				IHook _JascoHook = (IHook) _JascoHooksI.next();
				TraversalHookWrapper wrapper = (TraversalHookWrapper) beforeWrappers.get(_JascoHook);
				if(wrapper==null) continue;
				String contextclass = context.getClass().getName();
				JascoMethod jascomethod = getJascoMethod(wrapper,context); 
				if(wrapper.matchesContext(contextclass)&&wrapper.isApplicable(jascomethod))
				temphooks.add(wrapper);
			}
			Collections.sort(temphooks);
			HookList hooks = new HookList();
			_JascoHooksI = temphooks.iterator();
			while(_JascoHooksI.hasNext()) {
				TraversalHookWrapper wrapper = (TraversalHookWrapper) _JascoHooksI.next();
				IHook _JascoHook = wrapper.getHook(); 
				hooks.addImpl(_JascoHook);
			}
			hooks=filterHooks(hooks);
			_JascoHooksI = hooks.getHooks().iterator();
			while(_JascoHooksI.hasNext()) {
				IHook _JascoHook = (IHook) _JascoHooksI.next();
				TraversalHookWrapper wrapper = (TraversalHookWrapper) beforeWrappers.get(_JascoHook);
				JascoMethod jascomethod = getJascoMethod(wrapper,context); 
				_JascoHook.before(jascomethod,jascomethod.getCalledObject(),jascomethod.getArgumentsArray());
			}
			}catch (Exception ex) {System.err.println(ex.getMessage());ex.printStackTrace();}
			around(context);
		
		}
	
	
		public  void after(Object context) throws JAsCoStopTraversal {
		
			try{Vector temphooks = new Vector();
			Iterator _JascoHooksI = registry.iterator();
			while(_JascoHooksI.hasNext()) {
				IHook _JascoHook = (IHook) _JascoHooksI.next();
				TraversalHookWrapper wrapper = (TraversalHookWrapper) afterWrappers.get(_JascoHook);
				if(wrapper==null) continue;
				String contextclass = context.getClass().getName();
				JascoMethod jascomethod = getJascoMethod(wrapper,context); 
				if(wrapper.matchesContext(contextclass)&&wrapper.isApplicable(jascomethod))
				temphooks.add(wrapper);
			}
			Collections.sort(temphooks);
			HookList hooks = new HookList();
			_JascoHooksI = temphooks.iterator();
			while(_JascoHooksI.hasNext()) {
				TraversalHookWrapper wrapper = (TraversalHookWrapper) _JascoHooksI.next();
				IHook _JascoHook = wrapper.getHook(); 
				hooks.addImpl(_JascoHook);
			}
			hooks=filterHooks(hooks);
			_JascoHooksI = hooks.getHooks().iterator();
			while(_JascoHooksI.hasNext()) {
				IHook _JascoHook = (IHook) _JascoHooksI.next();
				TraversalHookWrapper wrapper = (TraversalHookWrapper) afterWrappers.get(_JascoHook);
				JascoMethod jascomethod = getJascoMethod(wrapper,context); 
				_JascoHook.after(jascomethod,jascomethod.getCalledObject(),jascomethod.getArgumentsArray());
			}
			}catch (Exception ex) {System.err.println(ex.getMessage());ex.printStackTrace();}
		
		}
	
	
		public  void around(Object context) throws JAsCoStopTraversal {
		
			try{Vector temphooks = new Vector();
			Iterator _JascoHooksI = registry.iterator();
			while(_JascoHooksI.hasNext()) {
				IHook _JascoHook = (IHook) _JascoHooksI.next();
				TraversalHookWrapper wrapper = (TraversalHookWrapper) aroundWrappers.get(_JascoHook);
				if(wrapper==null) continue;
				String contextclass = context.getClass().getName();
				TraversalJascoMethod jascomethod = getJascoMethod(wrapper,context); 
				if(wrapper.matchesContext(contextclass)&&wrapper.isApplicable(jascomethod))
				temphooks.add(wrapper);
			}
			Collections.sort(temphooks);
			HookList hooks = new HookList();
			_JascoHooksI = temphooks.iterator();
			while(_JascoHooksI.hasNext()) {
				TraversalHookWrapper wrapper = (TraversalHookWrapper) _JascoHooksI.next();
				IHook _JascoHook = wrapper.getHook(); 
				hooks.addImpl(_JascoHook);
			}
			hooks=filterHooks(hooks);
			_JascoHooksI = hooks.getHooks().iterator();
			while(_JascoHooksI.hasNext()) {
				IHook _JascoHook = (IHook) _JascoHooksI.next();
				TraversalHookWrapper wrapper = (TraversalHookWrapper) aroundWrappers.get(_JascoHook);
				TraversalJascoMethod jascomethod = getJascoMethod(wrapper,context); 
				_JascoHook.around(jascomethod,jascomethod.getCalledObject(),jascomethod.getArgumentsArray());
				if(jascomethod.doContinue())
					jascomethod.doContinue(false);
				else stopTraversal(context);
			}
			}catch (Exception ex) {System.err.println(ex.getMessage());ex.printStackTrace();}
		
		}
	
	
		public  void stopTraversal(Object context) throws JAsCoStopTraversal {
		
			throw new JAsCoStopTraversal(context);
		
		}
	
	
	
	}

}