package test.arounds;

class ObjectAroundTest {
	
	hook MyHook {
		
		MyHook(String method(..args)) {
			execution(method);
		}
		
		around() {
			String i= proceed();
			System.out.println("aspect:"+i);
			return i;
		}
	}
	
	hook MyHook3 {
		
		MyHook3(String method(..args)) {
			execution(method);
		}
		
		around() {
			String i= proceed(thisJoinPointObject,args);
			System.out.println("aspect:"+i);
			return i;
		}
	}
	
	hook MyHook2 {
		
		MyHook2(String method(..args)) {
			execution(method);
		}
		
		around returning(String k) {
			System.out.println("aspect:"+k);
			return k;
		}
	}
}
